﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.5
@EndOfDesignText@
Sub Class_Globals
	Private errorLogEntry As 		Int = 0
	Private warningLogEntry As 		Int = 1
	Private informationLogEntry As 	Int = 2
	Private DebugResultLogEntry As 	Int = 3
'	
	Dim saLogType() As String = Array As String ("E","W","I","T")

	Dim Const textExtension As String = ".txt"
	Private sFileName As String
	Private sLogFilePath As String

	Private logTimer As Timer

	Type logEntryStruct (logType As Int, timeAndDate As Long, Module As String, Routine As String, Message As String)
	Public faultReportingList As List
	Public myLogDebugResults As Boolean
	
End Sub
'---------------------------------------------------------------------------------
'---------------------------------------------------------------------------------
' delete tomorrow file if it exists
' is not designed to run over midnight
Public Sub Initialize(pathName As String, logFileName As String )
'Dim fileToDelete As String
	Dim sMonth, sDay As String
	Try 
		If File.Exists(File.DirRootExternal & "/TestApp", "") = False Then
			File.MakeDir(File.DirRootExternal & "/TestApp","")
		End If
	Catch 
	End Try

	
	If DateTime.GetMonth(DateTime.Now) < 10 Then: sMonth = "0" & DateTime.GetMonth(DateTime.Now)
	Else:										  sMonth =       DateTime.GetMonth(DateTime.Now)
	End If
	
	If DateTime.GetDayOfMonth(DateTime.Now) < 10 Then: sDay = "0" & DateTime.GetDayOfMonth(DateTime.Now)
	Else:											   sDay =       DateTime.GetDayOfMonth(DateTime.Now)
	End If
	
	sFileName = logFileName&"_"&DateTime.GetYear(DateTime.Now)&"_"&sMonth&"_"&sDay&textExtension
	sLogFilePath = pathName
	If File.Exists (pathName,"") = False Then File.MakeDir(pathName,"")' MAKE THE DIRECTORI IF THE DIRECTORI IS NOT CREATED
	
	DeleteOldFiles(pathName)
	Globals.PathMediaScanner(pathName)
	Globals.FileMediaScanner(pathName, logFileName)
	
	faultReportingList.Initialize
	myLogDebugResults = True
	logTimer.Initialize("LogTimer",250)
	logTimer.Enabled = True
	DateTime.TimeFormat = "HH:mm:ss:SSS"
	
	LogInformation("TrsLogClass", "Initialize", "Log file is " & sFileName)
	'Return 1
End Sub
'---------------------------------------------------------------------------------
'delete old files if the number of files iF over a certain number (60 IS THE NUMBER)
private Sub DeleteOldFiles(path As String ) As ResumableSub
	Try
		Dim fileList As List
		Dim n As Int
		Dim sFileToDelete As String

		fileList = File.ListFiles(path)
		fileList.Sort(True)
		If fileList.Size-1 > 60 Then 
			For n = 60 To fileList.Size-1
				sFileToDelete = fileList.Get(n)
				If File.IsDirectory(path,sFileToDelete) = True Then
					File.Delete(path,sFileToDelete)
				End If
			Next
		End If
		Return 1
	Catch
		Return 0 
	End Try
End Sub
'---------------------------------------------------------------------------------
Public Sub Flush
	LogTimer_Tick
End Sub
'---------------------------------------------------------------------------------
'---------------------------------------------------------------------------------
'write to the log file - could include a midnight check if required
Sub LogTimer_Tick()
	Try
		If faultReportingList.Size = 0 Then Return	' nothing to do
		
		Dim TextWriter1 As TextWriter
		TextWriter1.Initialize(File.OpenOutput(sLogFilePath, sFileName, True))
		
		Do While faultReportingList.Size > 0
			Dim entry  As logEntryStruct = faultReportingList.Get(0)
			faultReportingList.RemoveAt(0)
			Dim strToLog As String = "["&DateTime.Time(entry.timeAndDate) &"]| '" & saLogType(entry.logType)&"' |"&entry.Module&"|"&entry.Routine&"|"&entry.Message
			TextWriter1.WriteLine(strToLog)
		Loop
		
		Globals.PathMediaScanner(sLogFilePath)
		TextWriter1.Close
	Catch
		Log(LastException)
	End Try
End Sub
'---------------------------------------------------------------------------------
'---------------------------------------------------------------------------------
'with ToastMessageShow set on short duration
Public Sub LogInformation(sendingModule As String, sendingRoutine As String, theInformationMessage As String)
	Dim sf As StringFunctions
	sf.Initialize
	If theInformationMessage = Null Then theInformationMessage = "No error message!"
	If theInformationMessage.Length > 150 Then : ToastMessageShow(sf.Left(theInformationMessage,150), False)
	Else : ToastMessageShow(sf.Left(theInformationMessage,150), False)
	End If 
	Log("I: " & DateTime.Time(DateTime.Now) & " : " & sendingModule & " : " & sendingRoutine & " : " & theInformationMessage)
	Dim entry As logEntryStruct
	entry.Initialize
	entry.logType     = informationLogEntry
	entry.timeAndDate = DateTime.Now
	entry.Module      = sendingModule
	entry.Routine     = sendingRoutine
	entry.Message     = theInformationMessage
	faultReportingList.Add(entry)
End Sub
'---------------------------------------------------------------------------------
' with ToastMessageShow commented
Public Sub LogError(sendingModule As String, sendingRoutine As String, theFaultMessage As String, Trace As String )
	Dim sf As StringFunctions
	sf.Initialize
	If theFaultMessage = Null Then theFaultMessage = "No error message!"
'	If theFaultMessage.Length > 150 Then : ToastMessageShow(sf.Left(theFaultMessage,150), False)
'	Else : ToastMessageShow(sf.Left(theFaultMessage,150), False)
'	End If
	Log("E: " & DateTime.Time(DateTime.Now) & " : " & sendingModule & " : " & sendingRoutine & " : " & theFaultMessage)
	Dim entry As logEntryStruct
	entry.Initialize
	entry.logType     = errorLogEntry
	entry.timeAndDate = DateTime.Now
	entry.Module      = sendingModule
	entry.Routine     = sendingRoutine
	entry.Message     = theFaultMessage & CRLF & Trace
	faultReportingList.Add(entry)
End Sub
'---------------------------------------------------------------------------------
'with ToastMessageShow set on short duration
Public Sub LogWarning(sendingModule As String, sendingRoutine As String, theWarningMessage As String)
	Dim sf As StringFunctions
	sf.Initialize
	If theWarningMessage = Null Then theWarningMessage = "No error message!"
	If theWarningMessage.Length > 150 Then : ToastMessageShow(sf.Left(theWarningMessage,150), False)
	Else : ToastMessageShow(sf.Left(theWarningMessage,150), False)
	End If
	Log("W: " & DateTime.Time(DateTime.Now) & " : " & sendingModule & " : " & sendingRoutine & " : " & theWarningMessage)
	Dim entry As logEntryStruct
	entry.Initialize
	entry.logType     = warningLogEntry
	entry.timeAndDate = DateTime.Now
	entry.Module      = sendingModule
	entry.Routine     = sendingRoutine
	entry.Message     = theWarningMessage
	faultReportingList.Add(entry)
End Sub
'---------------------------------------------------------------------------------
' can be turned off to suppress Debug results
' with ToastMessageShow commented
Public Sub LogDebug(sendingModule As String, sendingRoutine As String, theDebugMessage As String)
	If myLogDebugResults = False Then Return
	Dim sf As StringFunctions
	sf.Initialize
	If theDebugMessage = Null Then theDebugMessage = "No error message!"
'	If theDebugMessage.Length > 150 Then : ToastMessageShow(sf.Left(theDebugMessage,150), False)
'	Else : ToastMessageShow(sf.Left(theDebugMessage,150), False)
'	End If
	Log("D: " & DateTime.Time(DateTime.Now) & " : " & sendingModule & " : " & sendingRoutine & " : " & theDebugMessage)
	Dim entry As logEntryStruct
	entry.Initialize
	entry.logType     = DebugResultLogEntry
	entry.timeAndDate = DateTime.Now
	entry.Module      = sendingModule
	entry.Routine  	  = sendingRoutine
	entry.Message     = theDebugMessage
	faultReportingList.Add(entry)
End Sub
'---------------------------------------------------------------------------------
Public Sub LogDebugResults(nv As Boolean)
	myLogDebugResults = nv
End Sub
